CREATE TABLE PARAMINTBALANCA  (
    CDFILIAL        		VARCHAR2(04) 			NOT NULL ,
    IDUTILBALANCA   		VARCHAR2(01) 			DEFAULT 'N' 
	CONSTRAINT CKC_IDUTILBALANCA CHECK (IDUTILBALANCA IN ('N', 'S')) NOT NULL ,
    CDPORTABALANCA  	VARCHAR2(10),
    IDTIPOCONEXAO 		VARCHAR2(10)			 DEFAULT 'SERIAL' 
	CONSTRAINT CKC_IDTIPOCONEXAO CHECK (IDTIPOCONEXAO IN ('SERIAL', 'TCP/IP')) NOT NULL ,
    IDMODELOBALANCA 	VARCHAR2(02) 			DEFAULT '00' 
	CONSTRAINT CKC_IDMODELOBALANCA CHECK (IDMODELOBALANCA IN ('00', '0','1','3','6','10','13','16')) NOT NULL ,
    DSIPBALANCA         VARCHAR2(20),
    VRPERINCMAIORNF 	FLOAT ,
    VRPERINCMENORNF 	FLOAT ,
    CDTPORETIPADR   		VARCHAR2(02) ,
    CDSETORESTOQ    		VARCHAR2(04) ,
    IDMODELOIMPRES  	VARCHAR2(02) 			DEFAULT '00' 
	CONSTRAINT CKC_IDMODELOIMPRES CHECK (IDMODELOIMPRES IN ('00','01')) NOT NULL ,
    CDPORTAIMPRES   	VARCHAR2(10) ,
    CDETIQUEPADR    	VARCHAR2(200) ,
    CDGRUPOPER_RECE 	VARCHAR2(02),
    NRORG           		NUMBER 				DEFAULT 1 NOT NULL ,
    DTINCLUSAO      		DATE ,
    DTULTATU        		DATE ,
    NRORGINCLUSAO   	NUMBER ,
    CDOPERINCLUSAO  	VARCHAR2(12) ,
    NRORGULTATU     		NUMBER ,
    CDOPERULTATU    		VARCHAR2(12) ,
    IDATIVO         		VARCHAR2(01) 			DEFAULT 'S' CONSTRAINT CKC_IDATIVO_PARAMINTBAL CHECK ( IDATIVO IN ('N','S')) NOT NULL
  )
/
ALTER TABLE PARAMINTBALANCA ADD CONSTRAINT PK_PARAMINTBALANCA PRIMARY KEY(CDFILIAL)
/
ALTER TABLE AUTGRUPOP DROP CONSTRAINT CKC_IDAUTGRUPOP
/
ALTER TABLE AUTGRUPOP ADD CONSTRAINT CKC_IDAUTGRUPOP CHECK (  
   IDAUTGRUPOP IN ('PCMP','PROD','INAC','ALAC','ENAC','VIAC','INDF','STAR','VALI', 
                   'CONT','VPLA','VPLT','VERI','QUAL','VLIB','CINS','CANA','LLOT', 
                   'FINC','TARE','IRET','RCUS','MABD','BLPR','CARD','REIP','ENAF', 
                   'CAAF','ABAF','APRC','PLPR','CFEC','APBC','REBC','BSOL','BKGA', 
                   'ARRV','SFOS','LBPS','APCO','EFCO','CACO','ALCO','LCMR','LRCD', 
                   'EXBR','EXBP','PROP','APAF','GEAF','RECC','EXCP','EMAP','ACSA', 
                   'AAPR','ACRM','COIM','ACTF','ACPS','PSUP','MTRA','PAOC','INCT', 
                   'CMIS','CENA','GECO','ESVN','GEST','GGER','GAUD','CRMP','CRMR', 
                   'CDGE','ALAT','ACET','ATPR','CLOT','ADSO','APSG','BLOL','AUDP', 
                   'CPRC','SVOL','PROC','DELI','METC','CONF','LOGS','LOGC','PEOL', 
                   'EXAF','SBTP','ACEP','DPAP','ATLC','PEME','PRVE','PRVC','EEEA',
                   'BLIP','TPED','ALTC','ALTP','ALEE','ALEP','AUPA','ALAF','IINP', 
                   'LIRB','ALOP'))
/
ALTER TABLE PRODUTO ADD VRTARA FLOAT
/
CREATE TABLE PRODFILIPESAGEM  (
   CDFILIAL  		VARCHAR2(04 BYTE)		NOT NULL ,
   CDPRODUTO 		VARCHAR2(10 BYTE) 		NOT NULL ,
   VRTARA 			FLOAT,
   NRORG                		NUMBER              		DEFAULT 1 NOT NULL,
   IDATIVO              		VARCHAR2(1)     		DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_PRODFILIPESAGEM CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO           		DATE                   		NULL,
   DTULTATU             		DATE                  		NULL,
   NRORGINCLUSAO        	NUMBER             		DEFAULT 1 NULL,
   CDOPERINCLUSAO       	VARCHAR2(12)  		DEFAULT '1' NULL,
   NRORGULTATU         		NUMBER             		DEFAULT 1 NULL,
   CDOPERULTATU         	VARCHAR2(12)  		DEFAULT '1'
  )
/
ALTER TABLE PRODFILIPESAGEM ADD CONSTRAINT PK_PRODFILIPESAGEM PRIMARY KEY (CDFILIAL, CDPRODUTO)
/
CREATE INDEX FIS00650_FK ON PRODFILIPESAGEM (CDFILIAL, CDPRODUTO)
/
ALTER TABLE PRODFILIPESAGEM ADD 
	CONSTRAINT FKFIS00650PRODFILI FOREIGN KEY (CDFILIAL, CDPRODUTO) 
		REFERENCES PRODFILI (CDFILIAL, CDPRODUTO) ON DELETE CASCADE
/
CREATE TABLE FORPRODPESAGEM (
    CDFORNECED 		VARCHAR2(21) 		NOT NULL ,
    CDFILIAL   		VARCHAR2(02) 		NOT NULL ,
    CDPRODUTO  		VARCHAR2(10) 		NOT NULL ,
    VRTARAPRODFORN 	FLOAT,
    NRORG          		NUMBER			DEFAULT 1 NOT NULL ,
   IDATIVO              		VARCHAR2(1)     		DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_FORPRODPESAGEM   	CHECK (IDATIVO IN ('S','N')),
    DTINCLUSAO      		DATE ,
    DTULTATU        		DATE ,
    NRORGINCLUSAO   	NUMBER ,
    CDOPERINCLUSAO  	VARCHAR2(12),
    NRORGULTATU     		NUMBER ,
    CDOPERULTATU    		VARCHAR2(12) 
  )
/
ALTER TABLE FORPRODPESAGEM ADD CONSTRAINT PK_FORPRODPESAGEM PRIMARY KEY (CDFORNECED, CDPRODUTO)
/
ALTER TABLE FORPRODPESAGEM 
	ADD CONSTRAINT FKFIS00651PRODFILI FOREIGN KEY (CDFILIAL, CDPRODUTO) 
		REFERENCES PRODFILI (CDFILIAL, CDPRODUTO) ON DELETE CASCADE
/
ALTER TABLE ITEMPRODUTO ADD CDPRODEMBALAGEM VARCHAR2(10)
/
CREATE INDEX FIS00652_FK ON ITEMPRODUTO (CDPRODEMBALAGEM)
/
ALTER TABLE ITEMPRODUTO ADD
	CONSTRAINT FKFIS00652PRODUTO FOREIGN KEY (CDPRODEMBALAGEM) 
		REFERENCES PRODUTO (CDPRODUTO)
/
ALTER TABLE ITEMPRODUTO ADD IDACAO VARCHAR2(02) CONSTRAINT CKC_IDACAO CHECK (IDACAO IN (NULL, '0', '1', '2'))
/
ALTER TABLE ITEMPRODUTO ADD IDEXIGEAPROV VARCHAR2(02) CONSTRAINT CKC_IDEXIGEAPROV CHECK (IDEXIGEAPROV IN ('S', 'N', NULL))
/
ALTER TABLE ITEMPRODUTO ADD QTDIFEPESAPROD FLOAT
/
ALTER TABLE ITEMPRODUTO ADD IDPESADO VARCHAR2(01)
/
CREATE TABLE HISTPESAGEMPROD (
   CDFILIAL       		VARCHAR2(04),
   NRLANCTONF     		VARCHAR2(10),
   NRSEQITPROD    		VARCHAR2(04),
   NRSEQPESAGEM   		VARCHAR2(04),
   CDPRODUTO      		VARCHAR2(10),
   IDPESAR          		VARCHAR2(01) 
	CONSTRAINT CKC_IDPESAR_HISTPESAGEMPROD  CHECK (IDPESAR IN ('S','N')),
   DSLOTEFORNE    		VARCHAR2(50),
   DTVALIDADE     		DATE,
   QTPESOLIQ        		FLOAT,
   QTPESOBRUT       		FLOAT,
   VRVOLEMBALAGEM 	FLOAT,
   VRTARAINT        		FLOAT,
   VRTARAEXT        		FLOAT,
   NRORG               	 	NUMBER              	DEFAULT 1 NOT NULL,
   IDATIVO              		VARCHAR2(1)     	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_HISTPESAGEMPROD  CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO            		DATE                   	NULL,
   DTULTATU             		DATE                  	NULL,
   NRORGINCLUSAO      	NUMBER             	DEFAULT 1 NULL,
   CDOPERINCLUSAO    	VARCHAR2(12)  	DEFAULT '1' NULL,
   NRORGULTATU          	NUMBER             	DEFAULT 1 NULL,
   CDOPERULTATU        		VARCHAR2(12)  	DEFAULT '1'
  )
/
ALTER TABLE HISTPESAGEMPROD ADD CONSTRAINT PK_HISTPESAGEMPROD PRIMARY KEY (CDFILIAL, NRLANCTONF, NRSEQITPROD, NRSEQPESAGEM)
/
CREATE INDEX FIS00653_FK ON HISTPESAGEMPROD (CDFILIAL, NRLANCTONF, NRSEQITPROD)
/
ALTER TABLE HISTPESAGEMPROD ADD
	 CONSTRAINT FKFIS00653ITEMPROD FOREIGN KEY (CDFILIAL, NRLANCTONF, NRSEQITPROD) 
		REFERENCES ITEMPRODUTO (CDFILIAL, NRLANCTONF, NRSEQITPROD) ON DELETE CASCADE